/* Test for Coco. Copyright (C) 1994 Yasumsa uyama.	Parser module */

 //CONST
#define cmaxname    73
#define cmaxnamep   19
#define cmaxcode   133
#define cmaxany      1
#define cmaxeps      4
#define cmaxt       12
#define cmaxp       12
#define cmaxs       19
#define cstartpc	 129






//CONST  /*G-code instructions*/
#define t 0
#define ta 1
#define nt 2
#define nta 3
#define nts 4
#define ntas 5
#define any 6
#define anya 7
#define eps 8
#define epsa 9
#define jmp 10
#define ret 11
#define errdistmin 2
#define lmaxs 50

#define eofsy 0
#define numsy 1
#define cellsy 2
#define funcsy 3
#define plussy 4
#define minussy 5
#define timessy 6
#define dividesy 7
#define expsy    8
#define lparsy 9
#define rparsy 10
#define colonsy 11
#define nococosy 12

#define MAXFUNCNAMELEN 5

#define notyp 255
//#define buflen 1024//*16

#define idmax 200
//4980
#define htmax 100
//359

#include <string.h>
#include <alloc.h>
#include <math.h>
#include <ctype.h>
#include <errno.h>
#include <stdio.h>
#include <jctype.h>
#include "tcalc.h"


void Semant(unsigned int sem, int *att);
struct Pragma{
		unsigned int sem2;
		unsigned int sem3;
		};
struct Pragma Pragmalist[cmaxp-cmaxt+1];
struct SymbolnodeSYN{
		unsigned int startpc;
		enum Boolean del;
		unsigned int first[1+cmaxt/16];
		};
struct TAB{
		unsigned int header[8];
		unsigned char code[(cmaxcode/2+2)*2];
		struct SymbolnodeSYN ntsymbols[cmaxs-cmaxp];
		unsigned int epsset[cmaxeps][cmaxt/16+1];
		unsigned int anyset[cmaxany][cmaxt/16+1];
		unsigned int  nra[cmaxp+1];
		struct Pragma ps[cmaxp-cmaxt+1];
		unsigned int namep[cmaxnamep+1];
		char name[(cmaxname/2+2)*2];
		};
struct TAB *tab;
unsigned int altroot;
enum Boolean correct, corr;
unsigned int pc;
unsigned int errdist;
unsigned int is[lmaxs+1];
unsigned int lacts;
enum Boolean{False, True};
unsigned int typ;
unsigned int line;
unsigned int col;
unsigned int loc;
char accepted = FALSE;

/*TableContents   A dirty trick to initialize the grammar tables
------------------------------------------------------------------*/
unsigned int TABLE[]={
//  INLINE(
    133u,   12u,   12u,   19u,    4u,    0u,   19u,   73u,
/*---G-code---*/
    526u, 3083u,  527u,  260u,   18u, 3330u, 3854u, 2560u, 1793u, 1280u,
   7439u,  527u, 4106u,    7u, 2049u, 2818u, 4097u, 1536u,11537u,  528u,
   4618u,   34u,  263u,   56u, 4866u, 4116u, 2560u, 8712u,  523u,  529u,
    264u,   70u, 5378u, 4118u, 2824u,  779u,  786u,   78u, 2816u, 1282u,
   4631u, 2817u,  512u,25880u,  267u,   98u, 6400u,  538u, 2824u, 1035u,
    531u, 2817u, 2304u,28930u, 3584u, 2571u,  257u,  118u, 2816u,  768u,
   2331u,  526u, 7168u, 2571u,  525u,    0u, 2816u,
/*---nt-symbols---*/
      1u,    0u,  558u,    5u,    0u,  558u,   32u,    0u,  558u,   59u,
      0u,  558u,   73u,    0u,  558u,   84u,    0u,  526u,  104u,    0u,
		522u,
/*---eps followers---*/
   1025u, 1073u, 1265u, 1521u,
/*---any sets---*/
      0u,
/*---attribute numbers---*/
      0u,    0u,    0u,    0u,    0u,    0u,    0u,    0u,    0u,    0u,
			0u,    0u,    0u,
/*---pragma semantic---*/
      0u,    0u,
/*---name pointers---*/
      1u,    5u,    9u,   14u,   19u,   23u,   27u,   31u,   35u,   39u,
     43u,   47u,   51u,   60u,   62u,   64u,   66u,   68u,   70u,   72u,
/*---name list---*/
  17743u,17920u,20053u,19712u,17221u,19532u,   70u,21838u,17152u, 8747u,
   8704u, 8749u, 8704u, 8746u, 8704u, 8751u, 8704u, 8798u, 8704u, 8744u,
	 8704u, 8745u, 8704u, 8762u, 8704u,28271u,25455u,25455u,29561u,  115u,
    101u,  116u,  102u,  120u,  117u,  111u,    0u,0u};

//	END TableContents;





struct TOKENREC
{
 char state;
 union
 {
	double value;
	struct
	{
	 int row, col;
	} c;
	char funcname[MAXFUNCNAMELEN + 1];
 } x;
};

static struct TOKENREC stack[PARSERSTACKSIZE], curtoken;
int stacktop, tokentype, error;
char *input, isformula;

int matherr(struct exception *e)
{
 e->retval = HUGE_VAL;
 return(1);
} /* matherr */

int isfunc(char *s)
/* 񂪐֐ł TRUE AłȂ FALSE Ԃ */
{
 int len = strlen(s);

 if (strncmp(s, input, len) == 0)
 {
	strncpy(curtoken.x.funcname, input, len);
	curtoken.x.funcname[len] = 0;
	input += len;
	return(TRUE);
 }
 return(FALSE);
} /* isfunc */

void push(struct TOKENREC *token)
/* Vg[NX^bNɃvbV */
{
 if (stacktop == PARSERSTACKSIZE - 1)
 {
	errormsg(MSGSTACKERROR);
	error = TRUE;
 }
 else
	stack[++stacktop] = *token;
} /* push */

struct TOKENREC pop(void)
/* X^bNgbṽg[N|bv */
{
 return(stack[stacktop--]);
} /* pop */


double cellvalue(int col, int row)
/* w肳ꂽZ̒l𓾂 */
{
 if (cell[col][row] == NULL)
	return(0);
 if (cell[col][row]->attrib == TEXT)
	return(HUGE_VAL);
 if (cell[col][row]->attrib == FORMULA)
	return(cell[col][row]->v.f.fvalue);
 return(cell[col][row]->v.value);
} /* cellvalue */

void stringupper(char *s)
{
	while (*s)
	{
		if (iskanji(*s) && s[1])
			s++;
		else if (islower((unsigned char)*s))
			*s = toupper(*s);
		s++;
	}
}

//header file for cclex.cpp

int nexttoken(void)
/* ̓Xg[玟̃g[Nǂݍ */
{
 char *start, numstring[MAXINPUT+1];
 int decimal, len, numlen;

 while (*input == ' ')
	input++;
 if (*input == 0)
	{typ=eofsy;return(typ);}
 if (strchr("0123456789.", *input))
 {
	start = input;
	len = 0;
	decimal = FALSE;
	while ((isdigit((unsigned char)*input)) ||
	 ((*input == '.') && (!decimal)))
	 {
	 if (*input == '.')
			decimal = TRUE;
	 input++;
	 len++;
	 }
	if ((len == 1) && (start[0] == '.'))
	 {typ = nococosy; return(typ);}
	if (*input == 'E')
	 {
	 input++;
	 len++;
	 if (strchr("+-", *input) != NULL)
		{
		input++;
		len++;
		}
	 numlen = 0;
	 while ((isdigit((unsigned char)*input)) && (++numlen <= 3))
	 {
		input++;
		len++;
	 }
	}
	strncpy(numstring, start, len);
	numstring[len] = 0;
	curtoken.x.value = atof(numstring);
	if (errno == ERANGE)
	 {typ=nococosy; return(typ);}
	typ=numsy;
	return(typ);
 }
 else if (isalpha((unsigned char)*input))
 {
	if
	(isfunc("ABS") ||
	 isfunc("ACOS") ||
	 isfunc("ASIN") ||
	 isfunc("ATAN") ||
	 isfunc("COSH") ||
	 isfunc("COS") ||
	 isfunc("EXP") ||
	 isfunc("LOG10") ||
	 isfunc("LOG") ||
	 isfunc("POW10") ||
	 isfunc("ROUND") ||
	 isfunc("SINH") ||
	 isfunc("SIN") ||
	 isfunc("SQRT") ||
	 isfunc("SQR") ||
	 isfunc("TANH") ||
	 isfunc("TAN") ||
	 isfunc("TRUNC"))
		{typ=funcsy; return(typ);}
	if (formulastart(&input, &curtoken.x.c.col, &curtoken.x.c.row))
	{
	 isformula = TRUE;
	 typ=cellsy;
	 return(typ);
	}
	else
	 {typ=nococosy; return(typ);}
 }
 else switch(*(input++))
 {
	case '+' : typ=plussy;  return(typ);
	case '-' : typ=minussy; return(typ);
	case '*' : typ=timessy; return(typ);
	case '/' : typ=dividesy; return(typ);
	case '^' : typ=expsy;   return(typ);
	case ':' : typ=colonsy; return(typ);
	case '(' : typ=lparsy; return(typ);
	case ')' : typ=rparsy; return(typ);
	default  : typ=nococosy; return(typ);
 } /* switch */
} /* nexttoken */

//IMPLEMENTATION MODULE esem;
//FROM elex IMPORT at;


void Semant(unsigned int sem, int *att){
	 struct TOKENREC token1, token2;
	 int counter;

	switch(sem){
		case 11: break;

		case  12: /*line 39*/
				 if(isformula)
					{*att=FORMULA;}
				 else{*att=VALUE;}
				 push(&curtoken);
				 break;
		case  13: /*line 47*/
				 push(&curtoken);
				 break;
		case  14: /*line 49*/
				 token1=pop();
				 curtoken.x.value+=token1.x.value;
				 break;
		case  15: /*line 54*/
				 push(&curtoken);break;
		case  16: /*line 56*/
				 token1=pop();
				 curtoken.x.value = token1.x.value - curtoken.x.value ;
				 break;
		case  17: /*line 62*/
				 push(&curtoken);break;
		case  18: /*line 64*/
				 token1=pop();
				 curtoken.x.value*=token1.x.value;
				 break;
		case  19: /*line 68*/
				 push(&curtoken);break;
		case  20: /*line 70*/
				 token1=pop();
				 if(curtoken.x.value==0)
				 curtoken.x.value=HUGE_VAL;
				 else
				 curtoken.x.value = token1.x.value/curtoken.x.value;
				 break;
		case  21: /*line 78*/
				 push(&curtoken);break;
		case  22: /*line 80*/
				 token1=pop();
				 curtoken.x.value=pow(token1.x.value, curtoken.x.value);
				 break;
		case  23: /*line 87*/
				 curtoken.x.value = -curtoken.x.value;
				 break;
		case  24: /*line 91*/
				 curtoken.x.value=cellvalue(curtoken.x.c.col,curtoken.x.c.row);
				 break;
		case  25: /*line 94*/
				 push(&curtoken);break;
		case  26: /*line 97*/
				 push(&curtoken);
					token1=pop();
					token2=pop();
				 curtoken.x.value=0;
				 if(token1.x.c.row==token2.x.c.row)
				 {
				 if(token1.x.c.col<token2.x.c.col)
				 error=TRUE;
				 else
				 {for(counter=token2.x.c.col;counter<=token1.x.c.col;counter++)
				 curtoken.x.value+=cellvalue(counter,token1.x.c.row);
				 }
				 }
				 else if(token1.x.c.col==token2.x.c.col)
				 {
				 if(token1.x.c.row<token2.x.c.row)
				 error=TRUE;
				 else
				 {for(counter=token2.x.c.row;counter<=token1.x.c.row;counter++)
				 curtoken.x.value+=cellvalue(token1.x.c.col,counter);
				 }
				 }
				 else
				 error=TRUE;
				 break;
		case  27: /*line 129*/
				 push(&curtoken);break;
		case  28: /*line 132*/
				 token1=pop();
				 if(strcmp(token1.x.funcname,"ABS")==0)
				 curtoken.x.value=fabs(curtoken.x.value);
				 else if(strcmp(token1.x.funcname,"ACOS")==0)
				 curtoken.x.value=acos(curtoken.x.value);
				 else if(strcmp(token1.x.funcname,"ASIN")==0)
				 curtoken.x.value=asin(curtoken.x.value);
				 else if(strcmp(token1.x.funcname,"ATAN")==0)
				 curtoken.x.value=atan(curtoken.x.value);
				 else if(strcmp(token1.x.funcname,"COSH")==0)
				 curtoken.x.value=cosh(curtoken.x.value);
				 else if(strcmp(token1.x.funcname,"COS")==0)
				 curtoken.x.value=cos(curtoken.x.value);
				 else if(strcmp(token1.x.funcname,"EXP")==0)
				 curtoken.x.value=exp(curtoken.x.value);
				 else if(strcmp(token1.x.funcname,"LOG10")==0)
         curtoken.x.value=log10(curtoken.x.value);
         else if(strcmp(token1.x.funcname,"LOG")==0)
         curtoken.x.value=log(curtoken.x.value);
         else if(strcmp(token1.x.funcname,"ROUND")==0)
         curtoken.x.value=(int)(curtoken.x.value+0.5);
				 else if(strcmp(token1.x.funcname,"POW10")==0)
				 curtoken.x.value=pow10(curtoken.x.value);
         else if(strcmp(token1.x.funcname,"SINH")==0)
         curtoken.x.value=sinh(curtoken.x.value);
         else if(strcmp(token1.x.funcname,"SIN")==0)
				 curtoken.x.value=sin(curtoken.x.value);
				 else if(strcmp(token1.x.funcname,"SQRT")==0)
         curtoken.x.value=sqrt(curtoken.x.value);
         else if(strcmp(token1.x.funcname,"SQR")==0)
         curtoken.x.value*=curtoken.x.value;
         else if(strcmp(token1.x.funcname,"TANH")==0)
         curtoken.x.value=tanh(curtoken.x.value);
         else if(strcmp(token1.x.funcname,"TAN")==0)
				 curtoken.x.value=tan(curtoken.x.value);
				 else if(strcmp(token1.x.funcname,"TRUNC")==0)
         curtoken.x.value=(int)curtoken.x.value;
         break;
		default:
			break;
			}/* switch */
		}/* Semant*/





/*Match     Check if sy is mumber of the specified set
------------------------------------------------------*/
enum Boolean Match(unsigned int sy,unsigned int set[]){
			if(set[sy/16]&(0x0001<<(sy%16))){return True; }
			else {return False; }
			}/* Match() */

/*NextSym     Get next symbol
----------------------------------------*/
void NextSym(int *att){
			while(1){
				nexttoken();
				if(typ<=cmaxt){   // typ is external variable.
					return ;
					}
				if(correct && (tab->ps[typ-cmaxt].sem2!=0)){
					Semant(tab->ps[typ-cmaxt].sem2, att);
					}
				if(correct && (tab->ps[typ-cmaxt].sem3!=0)){
					Semant(tab->ps[typ-cmaxt].sem3, att);
					}
				if(typ==eofsy){
					return;
					}
				}
			}/* NextSym() */



/*================= SYNTAXSTACK ===================*/

/*Pop
---------------*/
void Pop(unsigned int *loc){

			if(lacts>0){
				*loc=is[lacts]; lacts--;
				}
			else{
				printf("--- Parser stack underflow.$");
 //				getch(); /* HALT */
				}
			}/* Pop() */

/*Push
------------*/
void Push(unsigned int loc){

			if(lacts<lmaxs){
				lacts++; is[lacts]=loc;
				}
			else{
				printf("--- Parser stack overflow.$");
		//		getch();  /*HALT*/
				}
			}/* Push() */


/*Parse      Proper syntax analyzer
-------------------------------------*/
double parse(char *s, int *att){
/*  s \͂ - ]̒lԂƂƂɁA
 (TEXT = 0ACONSTANT = 1AFORMULA = 2)  att Ɋi[B
*/
 enum Boolean mustread;
 unsigned int opcode;
 enum Boolean running;
 unsigned int sy,tmp,tmp1;
 int i;
 struct TOKENREC firsttoken;
 char copy[MAXINPUT+1];

 error = FALSE;
 isformula = FALSE;
 input = copy;
 stringupper(strcpy(copy, s));
 stacktop = -1;
 firsttoken.state = 0;
 firsttoken.x.value = 0;
 push(&firsttoken);

 tab=(struct TAB *)malloc(sizeof(struct TAB));
		for(i=0;i<8;i++){
				*((unsigned int *)tab+i)=*(TABLE+i);
				}
			for(i=8;i<=8;i++){
				tmp=*(TABLE+i);
				*((unsigned int *)tab+i)=(tmp&0xff00);
				}
			for(i=9;i<(8+cmaxcode/2+1);i++){
				tmp=*(TABLE+i-1);
				tmp1=*(TABLE+i);
				*((unsigned int *)tab+i)=((tmp1&0xff00)|(tmp&0x00ff));
				}
			for(i=8+(cmaxcode/2)+cmaxcode%2;
							i<(8+(cmaxcode/2)+cmaxcode%2+5*(cmaxs-cmaxp)
							 +cmaxeps*3+cmaxany*3+cmaxp+1
							 +(cmaxp-cmaxt+1)*2+cmaxnamep+1);i++){
				*((unsigned int *)tab+i+1+(cmaxcode+1)%2)=*(TABLE+i);
				}
			for(i=(8+(cmaxcode/2)+cmaxcode%2+5*(cmaxs-cmaxp)
							 +cmaxeps*3+cmaxany*3+cmaxp+1
							 +(cmaxp-cmaxt+1)*2+cmaxnamep+1);
							i<(8+(cmaxcode/2)+cmaxcode%2+5*(cmaxs-cmaxp)
							 +cmaxeps*3+cmaxany*3+cmaxp+1
							 +(cmaxp-cmaxt+1)*2+cmaxnamep+1
							 +(cmaxname/2+2));
							 i++){
				tmp=*(TABLE+i);
				*((unsigned int *)tab+i+1+(cmaxcode+1)%2)=((tmp&0x00ff)<<8)|((tmp&0xff00)>>8);
				}

			pc=cstartpc; altroot=pc;
			line=1; col=1;
			correct=True; mustread=True; running=True;

			while(running){
				opcode=tab->code[pc];
				if(mustread && opcode<=epsa){
					NextSym(att); mustread=False; errdist++; altroot=pc;
					}
				pc++;
				switch(opcode){
					case t:
						if(typ==tab->code[pc]){
							if(typ==eofsy){
								running=False;
								}
							else{
								pc++; mustread=True;
								}
							}
						else{
							 //			 if(error)
					*att=TEXT;
					return(0.0);
					//		Error(pc,altroot);
							}
						break;
					case ta:
						if(typ==tab->code[pc]){
							pc=pc+3; mustread=True;
							}
						else{
							pc=256*tab->code[pc+1]+tab->code[pc+2];
							}
						break;
					case nt:
					case nts:
						sy=tab->code[pc];
						if(Match(typ,(tab->ntsymbols[sy-cmaxp-1].first)) ||
										 tab->ntsymbols[sy-cmaxp-1].del){
							if(opcode==nts){
								pc++; Semant(tab->code[pc],att);
								}
							Push(pc+1); pc=tab->ntsymbols[sy-cmaxp-1].startpc;
							altroot=pc;
							}
						else{
			 //							 if(error)
				 //	{
					*att=TEXT;
					return(0.0);
				//	}
			//				Error(pc,altroot);
							}
						break;
					case nta:
					case ntas:
						sy=tab->code[pc];
						if(Match(typ,tab->ntsymbols[sy-cmaxp-1].first)){
							pc=pc+3;
							if(opcode==ntas){
								Semant(tab->code[pc],att); pc++;
								}
							Push(pc); pc=tab->ntsymbols[sy-cmaxp-1].startpc;
							altroot=pc;
							}
						else{
							pc=tab->code[pc+1]*256+tab->code[pc+2];
							}
						break;
					case any:
						mustread=True;
						break;
					case anya:
						if(Match(typ,tab->anyset[tab->code[pc]-1])){
							pc=pc+3; mustread=True;
							}
						else{
							pc=tab->code[pc+1]*256+tab->code[pc+2];
							}
						break;
					case eps:
						if(Match(typ,tab->epsset[tab->code[pc]-1])){
							pc++;
							}
						else{
					//					 if(error)
				 //	{
					*att=TEXT;
					return(0.0);
				 //	}
				//			Error(pc,altroot);
							}
						break;
					case epsa:
						if(Match(typ,tab->epsset[tab->code[pc]-1])){
							pc=pc+3;
							}
						else{
							pc=tab->code[pc+1]*256+tab->code[pc+2];
							}
						break;
					case jmp:
						pc=tab->code[pc]*256+tab->code[pc+1];
						break;
					case ret:
						Pop(&pc); altroot=pc;
						break;
					default:
						if(correct){
							Semant(opcode,att);
							}
						break;
					}
				}
			corr=correct;
			free(tab);  /* add 1995-9-1 */
			return(stack[stacktop].x.value);
			}/* Parse() */

